#include <cmath>
#include "nummatrix.h"

template<class M>
double frobeniusnorm(const M & A)
{
    double sum = 0.0;
    for (typename M::ConstRowIterator rit = A.begin();
         rit != A.end(); ++rit)
    {
        for (typename M::ConstColIterator cit = rit->begin();
             cit != rit->end(); ++cit)
        {
            sum += (*cit) * (*cit);
        }
    }
    return sqrt(sum);
}

int main()
{
    MatrixClass<float> A(3,3);
    A(0,0) = 1;
    A(0,1) = 2;
    A(0,2) = 3;
    A(1,0) = 5;
    A(1,1) = 7;
    A(1,2) = 9;
    A(2,0) = 12;
    A(2,1) = 24;
    A(2,2) = 36;
    std::cout << frobeniusnorm(A) << std::endl;
}
